<?php

namespace Lc\CaracoleBundle\Definition\Field\Site;

use Lc\CaracoleBundle\Definition\Field\FieldDefinitionTrait;
use Lc\CaracoleBundle\Repository\Section\SectionStore;
use Lc\SovBundle\Definition\Field\Site\NewsFieldDefinition as SovNewsFieldDefinition;
use Lc\SovBundle\Translation\TranslatorAdmin;

class NewsFieldDefinition extends SovNewsFieldDefinition
{
    use FieldDefinitionTrait;

    protected SectionStore $sectionStore;

    public function __construct(TranslatorAdmin $translatorAdmin, SectionStore $sectionStore)
    {
        parent::__construct($translatorAdmin);
        $this->sectionStore = $sectionStore;
    }

    public function configureIndex(): array
    {
        return $this->addSectionToFieldArrayIfOutOfSection($this->section, parent::configureIndex());
    }

    public function configurePanelMain(): array
    {
        return array_merge(['section'], parent::configurePanelMain());
    }
}
